Attribute VB_Name = "GraphicsProcs"
Public mult
Public cd
Public statusPt
Public foundPt As Boolean


Public Function Draw()

On Error Resume Next
If Not fileLoaded Then Exit Function
Dim stereo As Boolean
stereo = fMainForm.chkStereo
grad = fMainForm.chkGradient
ColorW = fMainForm.chkColorW
If CurrentDisp Then cd = 0
If Not CurrentDisp Then cd = 1
fMainForm.picDisp(cd).DrawMode = 15
fMainForm.picDisp(cd).Cls
mult = fMainForm.picDisp(1).ScaleHeight / (Tan(Scene.FOV / 2) * Scene.Zdist)
Dim wmax As Double
wmax = 0
Dim wmin As Double
wmin = 0
For i = 1 To NumPoints
Dim prj As point
Dim prj1 As point
prj = translate(pointSet2(i), Scene.T)
ztemp = prj.Z
prj = MatMult(prj, Collapse(3, Scene.Wdist, prj.W + Scene.Wdist))
prj1 = prj
prj = MatMult(prj, Collapse(2, Scene.Zdist, ztemp + Scene.Zdist))
If stereo Then
    prj1 = MatMult(prj1, PlaneRotate(2, 0, ByVal Preferences.StereoSep))
    prj1 = MatMult(prj1, Collapse(2, Scene.Zdist, ztemp + Scene.Zdist))
End If
pointSetFinal1(i).X = prj.X
pointSetFinal2(i).X = prj1.X
pointSetFinal1(i).Y = prj.Y
pointSetFinal2(i).Y = prj1.Y

 
If pointSet2(i).W > wmax Then wmax = pointSet2(i).W
If pointSet2(i).W < wmin Then wmin = pointSet2(i).W

q = fMainForm.picDisp(1).ScaleHeight
fMainForm.picDisp(cd).PSet ((mult * prj.X) + fMainForm.picDisp(1).ScaleWidth / 2, (mult * prj.Y) + fMainForm.picDisp(1).ScaleHeight / 2), QBColor(9)
If stereo Then
    fMainForm.picDisp(cd).PSet ((mult * prj1.X) + fMainForm.picDisp(1).ScaleWidth / 2, (mult * prj1.Y) + fMainForm.picDisp(1).ScaleHeight / 2), QBColor(12)
End If
Next

wscale = (200 / (wmax - wmin))

For i = 1 To NumLines
  If grad Or ColorW Then
    c = ((-(pointSet2(lineSet(i).X).W - wmin) * wscale) - ((pointSet2(lineSet(i).Y).W - wmin) * wscale)) / 2 + 255
  Else: c = 255
  End If
  If ColorW Then
    blue = 255 - 3 * Abs((c - 255) Mod 255)
    red = 255 - 3 * Abs(c - 85)
    green = 255 - 3 * Abs(c - 170)
    If blue < 0 Then blue = 0
    If red < 0 Then red = 0
    If green < 0 Then green = 0
    fMainForm.Print ""
  Else
    blue = c
    red = 0
    green = 0
  End If
  If grad Then
    blue = blue * c / 255
    green = green * c / 255
    red = red * c / 255
  End If
  

fMainForm.picDisp(cd).Line ((mult * pointSetFinal1(lineSet(i).X).X) + fMainForm.picDisp(1).ScaleWidth / 2, (mult * pointSetFinal1(lineSet(i).X).Y) + fMainForm.picDisp(1).ScaleHeight / 2)-((mult * pointSetFinal1(lineSet(i).Y).X) + fMainForm.picDisp(1).ScaleWidth / 2, (mult * pointSetFinal1(lineSet(i).Y).Y) + fMainForm.picDisp(1).ScaleHeight / 2), RGB(red, green, blue)
If stereo Then
    fMainForm.picDisp(cd).Line ((mult * pointSetFinal2(lineSet(i).X).X) + fMainForm.picDisp(1).ScaleWidth / 2, (mult * pointSetFinal2(lineSet(i).X).Y) + fMainForm.picDisp(1).ScaleHeight / 2)-((mult * pointSetFinal2(lineSet(i).Y).X) + fMainForm.picDisp(1).ScaleWidth / 2, (mult * pointSetFinal2(lineSet(i).Y).Y) + fMainForm.picDisp(1).ScaleHeight / 2), RGB(blue, green, red)
End If

Next

fMainForm.picDisp(cd).ZOrder
CurrentDisp = cd
End Function


Function pointInfo(X, Y)
foundnewpt = False
pdist = 5
pt = 0
For i = 1 To NumPoints
    X1 = X - (mult * pointSetFinal1(i).X + fMainForm.picDisp(1).ScaleWidth / 2)
    Y1 = Y - (mult * pointSetFinal1(i).Y + fMainForm.picDisp(1).ScaleHeight / 2)

    dist = Sqr(X1 ^ 2 + Y1 ^ 2)
    If dist < pdist Then
        foundnewpt = True
        pt = i
        pdist = dist
    End If
Next
If foundnewpt And (pt <> statusPt Or (Not foundPt)) Then
fMainForm.picDisp(cd).DrawMode = 13
    foundPt = True
    'X = (mult * pointSetFinal1(statusPt).X + fMainForm.picDisp(1).ScaleWidth / 2)
    'Y = (mult * pointSetFinal1(statusPt).Y + fMainForm.picDisp(1).ScaleHeight / 2)
    'fMainForm.picDisp(cd).Line (X + 5, Y + 5)-(X - 5, Y - 5), QBColor(0)
    'fMainForm.picDisp(cd).PSet (X, Y), QBColor(0)
    Draw
    X = (mult * pointSetFinal1(pt).X + fMainForm.picDisp(1).ScaleWidth / 2)
    Y = (mult * pointSetFinal1(pt).Y + fMainForm.picDisp(1).ScaleHeight / 2)
    fMainForm.picDisp(cd).Circle (X, Y), 7, QBColor(9)
    fMainForm.lblStatus.Caption = "Point " + Str$(pt) + " [ " + Str$(pointSet(pt).X) + ", " + Str$(pointSet(pt).Y) + ", " + Str$(pointSet(pt).Z) + ", " + Str$(pointSet(pt).W) + "]"
    statusPt = pt
End If
If foundPt And Not foundnewpt Then
    'X = (mult * pointSetFinal1(statusPt).X + fMainForm.picDisp(1).ScaleWidth / 2)
    'Y = (mult * pointSetFinal1(statusPt).Y + fMainForm.picDisp(1).ScaleHeight / 2)
    'fMainForm.picDisp(cd).Line (X + 5, Y + 5)-(X - 5, Y - 5), QBColor(0)
    'fMainForm.picDisp(cd).PSet (X, Y), QBColor(0)
    fMainForm.lblStatus.Caption = ""
    Draw
    foundPt = False
End If

End Function
